KeyAgreement (GNU cryptographic primitives and tools)
Keywords: javax.crypto.KeyAgreement,KeyAgreement class

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.crypto
Class KeyAgreement

    java.lang.Object
      |
      +--javax.crypto.KeyAgreement

public class KeyAgreement
extends java.lang.Object

This class provides the functionality of a key agreement (or key exchange) protocol. The keys involved in establishing a shared secret are created by one of the key generators (`KeyPairGenerator` or `KeyGenerator`), a `KeyFactory`, or as a result from an intermediate phase of the key agreement protocol (see doPhase). For each of the correspondents in the key exchange, `doPhase` needs to be called. For example, if this key exchange is with one other party, `doPhase` needs to be called once, with the `lastPhase` flag set to `true`. If this key exchange is with two other parties, `doPhase` needs to be called twice, the first time setting the `lastPhase` flag to `false`, and the second time setting it to `true`. There may be any number of parties involved in a key exchange.

Since:
  1.4
See Also:
  `KeyGenerator`, `SecretKey`

Constructor Summary
`protected` | `KeyAgreement(KeyAgreementSpi keyAgreeSpi, java.security.Provider provider, java.lang.String algorithm)` Creates a KeyAgreement object.

Method Summary
`java.security.Key` | `doPhase(java.security.Key key, boolean lastPhase)` Executes the next phase of this key agreement with the given key that was received from one of the other parties involved in this key agreement.
`byte[]` | `generateSecret()` Generates the shared secret and returns it in a new buffer.
`int` | `generateSecret(byte[] sharedSecret, int offset)` Generates the shared secret, and places it into the buffer `sharedSecret`, beginning at `offset` inclusive.
`SecretKey` | `generateSecret(java.lang.String algorithm)` Creates the shared secret and returns it as a `SecretKey` object of the specified algorithm.
`java.lang.String` | `getAlgorithm()` Returns the algorithm name of this `KeyAgreement` object.
`static KeyAgreement` | `getInstance(java.lang.String algorithm)` Generates a `KeyAgreement` object that implements the specified key agreement algorithm.
`static KeyAgreement` | `getInstance(java.lang.String algorithm, java.security.Provider provider)` Generates a `KeyAgreement` object for the specified key agreement algorithm from the specified provider.
`static KeyAgreement` | `getInstance(java.lang.String algorithm, java.lang.String provider)` Generates a `KeyAgreement` object for the specified key agreement algorithm from the specified provider.
`java.security.Provider` | `getProvider()` Returns the provider of this `KeyAgreement` object.
`void` | `init(java.security.Key key)` Initializes this key agreement with the given key, which is required to contain all the algorithm parameters required for this key agreement.
`void` | `init(java.security.Key key, java.security.spec.AlgorithmParameterSpec params)` Initializes this key agreement with the given key and set of algorithm parameters.
`void` | `init(java.security.Key key, java.security.spec.AlgorithmParameterSpec params, java.security.SecureRandom random)` Initializes this key agreement with the given key, set of algorithm parameters, and source of randomness.
`void` | `init(java.security.Key key, java.security.SecureRandom random)` Initializes this key agreement with the given key and source of randomness.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### KeyAgreement

    protected KeyAgreement(KeyAgreementSpi keyAgreeSpi,
                           java.security.Provider provider,
                           java.lang.String algorithm)

  Creates a KeyAgreement object.

Parameters:
  `keyAgreeSpi` - the delegate
  `provider` - the provider
  `algorithm` - the algorithm

Method Detail

### getAlgorithm

    public final java.lang.String getAlgorithm()

  Returns the algorithm name of this `KeyAgreement` object.

  This is the same name that was specified in one of the `getInstance` calls that created this `KeyAgreement` object.

  Returns:
    the algorithm name of this `KeyAgreement` object.

### getInstance

    public static final KeyAgreement getInstance(java.lang.String algorithm)
                                          throws java.security.NoSuchAlgorithmException

  Generates a `KeyAgreement` object that implements the specified key agreement algorithm. If the default provider package provides an implementation of the requested key agreement algorithm, an instance of `KeyAgreement` containing that implementation is returned. If the algorithm is not available in the default provider package, other provider packages are searched.

  Parameters:
    `algorithm` - the standard name of the requested key agreement algorithm. See Appendix A in the Java Cryptography Extension API Specification & Reference for information about standard algorithm names.
  Returns:
    the new `KeyAgreement` object
  Throws:
    `java.security.NoSuchAlgorithmException` - if the specified algorithm is not available in the default provider package or any of the other provider packages that were searched.

### getInstance

    public static final KeyAgreement getInstance(java.lang.String algorithm,
                                                 java.lang.String provider)
                                          throws java.security.NoSuchAlgorithmException,
                                                 java.security.NoSuchProviderException

  Generates a `KeyAgreement` object for the specified key agreement algorithm from the specified provider.

  Parameters:
    `algorithm` - the standard name of the requested key agreement algorithm. See Appendix A in the Java Cryptography Extension API Specification & Reference for information about standard algorithm names.
    `provider` - the name of the provider
  Returns:
    the new `KeyAgreement` object
  Throws:
    `java.security.NoSuchAlgorithmException` - if the specified algorithm is not available from the specified provider.
    `java.security.NoSuchProviderException` - if the specified provider has not been configured.

### getInstance

    public static final KeyAgreement getInstance(java.lang.String algorithm,
                                                 java.security.Provider provider)
                                          throws java.security.NoSuchAlgorithmException

  Generates a `KeyAgreement` object for the specified key agreement algorithm from the specified provider. Note: the `provider` doesn't have to be registered.

  Parameters:
    `algorithm` - the standard name of the requested key agreement algorithm. See Appendix A in the Java Cryptography Extension Reference Guide for information about standard algorithm names.
    `provider` - the provider.
  Returns:
    the new `KeyAgreement` object
  Throws:
    `java.security.NoSuchAlgorithmException` - if the specified algorithm is not available from the specified provider.
    `java.lang.IllegalArgumentException` - if the provider is null.

### getProvider

    public final java.security.Provider getProvider()

  Returns the provider of this `KeyAgreement` object.

  Returns:
    the provider of this `KeyAgreement` object

### init

    public final void init(java.security.Key key)
                    throws java.security.InvalidKeyException

  Initializes this key agreement with the given key, which is required to contain all the algorithm parameters required for this key agreement.

  If this key agreement requires any random bytes, it will get them using the `SecureRandom` implementation of the highest-priority installed provider as the source of randomness. (If none of the installed providers supply an implementation of SecureRandom, a system-provided source of randomness will be used.)

  Parameters:
    `key` - the party's private information. For example, in the case of the Diffie-Hellman key agreement, this would be the party's own Diffie-Hellman private key.
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for this key agreement, e.g., is of the wrong type or has an incompatible algorithm type.

### init

    public final void init(java.security.Key key,
                           java.security.SecureRandom random)
                    throws java.security.InvalidKeyException

  Initializes this key agreement with the given key and source of randomness. The given key is required to contain all the algorithm parameters required for this key agreement.

  If the key agreement algorithm requires random bytes, it gets them from the given source of randomness, `random`. However, if the underlying algorithm implementation does not require any random bytes, `random` is ignored.

  Parameters:
    `key` - the party's private information. For example, in the case of the Diffie-Hellman key agreement, this would be the party's own Diffie-Hellman private key.
    `random` - the source of randomness
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for this key agreement, e.g., is of the wrong type or has an incompatible algorithm type.

### init

    public final void init(java.security.Key key,
                           java.security.spec.AlgorithmParameterSpec params)
                    throws java.security.InvalidKeyException,
                           java.security.InvalidAlgorithmParameterException

  Initializes this key agreement with the given key and set of algorithm parameters.

  If this key agreement requires any random bytes, it will get them using the `SecureRandom` implementation of the highest-priority installed provider as the source of randomness. (If none of the installed providers supply an implementation of SecureRandom, a system-provided source of randomness will be used.)

  Parameters:
    `key` - the party's private information. For example, in the case of the Diffie-Hellman key agreement, this would be the party's own Diffie-Hellman private key.
    `params` - the key agreement parameters
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for this key agreement, e.g., is of the wrong type or has an incompatible algorithm type.
    `java.security.InvalidAlgorithmParameterException` - if the given parameters are inappropriate for this key agreement.

### init

    public final void init(java.security.Key key,
                           java.security.spec.AlgorithmParameterSpec params,
                           java.security.SecureRandom random)
                    throws java.security.InvalidKeyException,
                           java.security.InvalidAlgorithmParameterException

  Initializes this key agreement with the given key, set of algorithm parameters, and source of randomness.

  Parameters:
    `key` - the party's private information. For example, in the case of the Diffie-Hellman key agreement, this would be the party's own Diffie-Hellman private key.
    `params` - the key agreement parameters
    `random` - the source of randomness
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for this key agreement, e.g., is of the wrong type or has an incompatible algorithm type.
    `java.security.InvalidAlgorithmParameterException` - if the given parameters are inappropriate for this key agreement.

### doPhase

    public final java.security.Key doPhase(java.security.Key key,
                                           boolean lastPhase)
                                    throws java.security.InvalidKeyException,
                                           java.lang.IllegalStateException

  Executes the next phase of this key agreement with the given key that was received from one of the other parties involved in this key agreement.

  Parameters:
    `key` - the key for this phase. For example, in the case of Diffie-Hellman between 2 parties, this would be the other party's Diffie-Hellman public key.
    `lastPhase` - flag which indicates whether or not this is the last phase of this key agreement.
  Returns:
    the (intermediate) key resulting from this phase, or null if this phase does not yield a key
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for this phase.
    `java.lang.IllegalStateException` - if this key agreement has not been initialized.

### generateSecret

    public final byte[] generateSecret()
                                throws java.lang.IllegalStateException

  Generates the shared secret and returns it in a new buffer.

  This method resets this `KeyAgreement` object, so that it can be reused for further key agreements. Unless this key agreement is reinitialized with one of the `init` methods, the same private information and algorithm parameters will be used for subsequent key agreements.

  Returns:
    the new buffer with the shared secret
  Throws:
    `java.lang.IllegalStateException` - if this key agreement has not been completed yet

### generateSecret

    public final int generateSecret(byte[] sharedSecret,
                                    int offset)
                             throws java.lang.IllegalStateException,
                                    ShortBufferException

  Generates the shared secret, and places it into the buffer `sharedSecret`, beginning at `offset` inclusive.

  If the `sharedSecret` buffer is too small to hold the result, a `ShortBufferException` is thrown. In this case, this call should be repeated with a larger output buffer.

  This method resets this `KeyAgreement` object, so that it can be reused for further key agreements. Unless this key agreement is reinitialized with one of the `init` methods, the same private information and algorithm parameters will be used for subsequent key agreements.

  Parameters:
    `sharedSecret` - the buffer for the shared secret
    `offset` - the offset in `sharedSecret` where the shared secret will be stored
  Returns:
    the number of bytes placed into `sharedSecret`
  Throws:
    `java.lang.IllegalStateException` - if this key agreement has not been completed yet
    `ShortBufferException` - if the given output buffer is too small to hold the secret

### generateSecret

    public final SecretKey generateSecret(java.lang.String algorithm)
                                   throws java.lang.IllegalStateException,
                                          java.security.NoSuchAlgorithmException,
                                          java.security.InvalidKeyException

  Creates the shared secret and returns it as a `SecretKey` object of the specified algorithm.

  This method resets this `KeyAgreement` object, so that it can be reused for further key agreements. Unless this key agreement is reinitialized with one of the `init` methods, the same private information and algorithm parameters will be used for subsequent key agreements.

  Parameters:
    `algorithm` - the requested secret-key algorithm
  Returns:
    the shared secret key
  Throws:
    `java.lang.IllegalStateException` - if this key agreement has not been completed yet
    `java.security.NoSuchAlgorithmException` - if the specified secret-key algorithm is not available
    `java.security.InvalidKeyException` - if the shared secret-key material cannot be used to generate a secret key of the specified algorithm (e.g., the key material is too short)

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001, 2002, 2003, 2004 Free Software Foundation, Inc.